Bug 195516 - Optimizing loads when creating new pages
Summary: Optimizing loads when creating new pages
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: WebKit Misc. (show other bugs)
Version: WebKit Nightly Build
Hardware: Unspecified Unspecified
: P2 Normal
Assignee: Jiewen Tan
URL:
Keywords: InRadar
Depends on:
Blocks:
 
Reported: 2019-03-09 01:17 PST by Jiewen Tan
Modified: 2019-03-11 17:58 PDT (History)
12 users (show)

See Also:


Attachments
Patch (22.55 KB, patch)
2019-03-09 01:28 PST, Jiewen Tan
no flags Details | Formatted Diff | Diff
Patch (22.56 KB, patch)
2019-03-10 00:06 PST, Jiewen Tan
no flags Details | Formatted Diff | Diff
Patch (22.56 KB, patch)
2019-03-10 00:28 PST, Jiewen Tan
no flags Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Jiewen Tan 2019-03-09 01:17:31 PST
Optimizing loads when creating new pages.
Comment 1 Radar WebKit Bug Importer 2019-03-09 01:20:47 PST
<rdar://problem/48738086>
Comment 2 Jiewen Tan 2019-03-09 01:28:08 PST
Created attachment 364123 [details]
Patch
Comment 3 Jiewen Tan 2019-03-09 01:28:52 PST
The internal counterpart is within: <rdar://problem/46325687>.
Comment 4 Build Bot 2019-03-09 01:29:32 PST
Thanks for the patch. If this patch contains new public API please make sure it follows the guidelines for new WebKit2 GTK+ API. See http://trac.webkit.org/wiki/WebKitGTK/AddingNewWebKit2API
Comment 5 Jiewen Tan 2019-03-10 00:06:09 PST
Created attachment 364175 [details]
Patch
Comment 6 Jiewen Tan 2019-03-10 00:28:26 PST
Created attachment 364178 [details]
Patch
Comment 7 Michael Catanzaro 2019-03-10 10:42:08 PDT
Comment on attachment 364178 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=364178&action=review

> Source/WebKit/UIProcess/WebPageProxy.h:2191
> +#if HAVE(LOAD_OPTIMIZER)
> +WEBPAGEPROXY_LOADOPTIMIZER_ADDITIONS_2
> +#endif

How do these hooks work?

It's strange that we would have non-open source code tightly coupled to open source like this. It's one thing to depend on an internal library, or to provide APIs for use by internal code, but just #including secret code into WebKit internals like this seems... unusual.

What gets optimized?
Comment 8 Darin Adler 2019-03-10 13:00:54 PDT
Comment on attachment 364178 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=364178&action=review

r+ so Jiewen can keep making progress

>> Source/WebKit/UIProcess/WebPageProxy.h:2191
>> +#endif
> 
> How do these hooks work?
> 
> It's strange that we would have non-open source code tightly coupled to open source like this. It's one thing to depend on an internal library, or to provide APIs for use by internal code, but just #including secret code into WebKit internals like this seems... unusual.
> 
> What gets optimized?

I understand your unease. But this has happened multiple times before before when an engineer at Apple started development on something that Apple wasn't ready to reveal. I think it’s OK for now; we can discuss it in more detail when someone from Apple upstreams everything. And it’s all inside an #if.
Comment 9 Jiewen Tan 2019-03-10 20:14:21 PDT
Comment on attachment 364178 [details]
Patch

Thanks Darin for r+ this patch.
Comment 10 WebKit Commit Bot 2019-03-10 20:41:19 PDT
Comment on attachment 364178 [details]
Patch

Clearing flags on attachment: 364178

Committed r242697: <https://trac.webkit.org/changeset/242697>
Comment 11 WebKit Commit Bot 2019-03-10 20:41:21 PDT
All reviewed patches have been landed.  Closing bug.
Comment 12 Truitt Savell 2019-03-11 08:55:12 PDT
Reverted r242697 for reason:

Broke internal builders.

Committed r242705: <https://trac.webkit.org/changeset/242705>
Comment 13 Jiewen Tan 2019-03-11 10:41:21 PDT
(In reply to Truitt Savell from comment #12)
> Reverted r242697 for reason:
> 
> Broke internal builders.
> 
> Committed r242705: <https://trac.webkit.org/changeset/242705>

Thanks for the heads up. I forgot that I have to land the OpenSource and Internal changes together. Will hold the same patch after the Internal one is ready to land.
Comment 14 Jiewen Tan 2019-03-11 17:58:03 PDT
Committed r242760: <https://trac.webkit.org/changeset/242760>